VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsDppConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public CfgReadBack As Boolean       'load dpp config into config editor
Public DisplayCfg As Boolean        'show dpp config in msgbox dialog
Public bSpectrumCfg As Boolean      'create dpp mca file config
Public ScaReadBack As Boolean       'parse/load sca settings into SCA controls
Public ScaReadReady As Boolean      'sca readback ready
Public DisplaySCA As Boolean       'parse/load sca settings into SCA controls

'' --------------------------------------------------------------------------------------
''  DppConfigSettingsType
'' --------------------------------------------------------------------------------------
'Public Type DPP_CONFIG_SETTINGS
    ' MCA Properties
    Public AcqMode As Byte           ' acquisition mode 0=MCA,1=MCS
    Public MCSTimebase As Byte       ' MCS timebase value (0-15) see CAcqMode
    Public MCAChannels As Byte       ' number of channels 0=256,1=512,2=1024,3=2048,4=4096,5=8192
    Public BufferSelect As Byte      ' Holds Buffer Sel A&B,Buffer Sel Hardware,see DPPBufferSelect
    Public TTLGate As Byte           ' gate input settings, determines events included/excluded from spectrum, see DPPGate
    Public SlowThreshold As Byte     ' Slow ch threshold, Events w/amp lower not added to spectrum
    Public PresetTime As Long        ' var holds preset time, used in usb
    Public PresetCount As Long       ' preset count in selected channels, ch are set in SCA8
    'Public SCA(0 To 7) As Long       ' SCA values, LL, UL, and Enable are stored together
    
    ' Shaping Properties
    Public TimeToPeak As Byte        ' TimeToPeak register setting
    Public Decimation As Byte        ' decimation setting for pulse shaping
    Public FlatTop As Byte           ' flatop register setting
    Public PUREnable As Byte         ' pile-up rejection enabled
    Public FastThreshold As Byte     ' Fast Ch Threshold, events w/fch amp below this are rejected
    Public RTDSlow As Byte           ' Risetime Discrimination slow threshold
    Public RTDOn As Byte             ' Turns RTD on, and sets the amplitude and timing thresholds
    Public RTDFast As Byte           ' RTD Time Threshold,Events w/HWHM wider than this are rejected
    Public BLR As Byte               ' Baseline Restoration, see udBLR.Value notes for values
    Public BaselineOn As Byte        ' use autobaseline during detector reset
    
    ' Gain PZ Properties
    Public CoarseGain As Byte        ' stores current coarse gain value
    Public FineGain As Long          ' stores current fine gain value
    Public PoleZero As Long          ' pole zero adjust value
    Public InputOffset As Long       ' input offset
    Public InputPolarity As Byte     ' use InvertEnable during detector reset
    Public DetReset As Byte          ' detector reset lockout period
    
    ' Power Properties
    Public TEC As Long               ' TEC temperature setting (displayed in Kelvin)
    Public HVEnabled As Byte         ' high voltage setting enable
    Public HV As Long                ' high voltage setting value
    Public PreampPower As Byte       ' preamp power select value (5v or 8.5v)
    
    ' Misc Properties
    Public AnalogOut As Byte         ' dac enabled and DAC output type,(stobed peak,shaped pulse,dec inp,fast ch)
    Public OutputOffset As Byte      ' Output DAC offset, -64+63,(signed)(D7-D1) (-500mV to +492mV)
    Public AuxOut As Byte            ' Aux output type
    Public AudibleCounter As Byte    ' audio volume setting
'End Type

'' --------------------------------------------------------------------------------------
''  DppStatusType (DPP_STATUS) DPP Status Storage Type
'' --------------------------------------------------------------------------------------
'Public Type DPP_STATUS

    ' Identification
    Public FPGA As Double              ' FPGA
    Public Firmware As Double          ' firmware revision
    Public SerialNumber As Double      ' unit serial number
    Public StatDevInd As Byte          ' device indicator from status block (0=dp4,1=px4)

    ' Configuration
    Public BootStatus As Byte          ' boot status byte (PwrBtnConfig,SwConfigRcvd,McaEnabled)
    Public PwrBtnConfig As Byte        ' dpp has loaded config from power button
    Public SwConfigRcvd As Byte        ' software has sent valid config to unit since startup

    ' Tuning
    Public SetFastThreshDone As Byte   ' DPP tune fast thresh has successfully done
    Public SetSlowThreshDone As Byte   ' DPP tune slow thresh has successfully done
    Public SetInputOffsetDone As Byte  ' DPP tune input offset has successfully done

    ' Monitors
    Public BoardTemp As Double         ' board temperature monitor value
    Public HVMonitor As Double         ' high voltage monitor value
    Public TECMonitor As Double        ' TEC temperature monitor value (displayed in Kelvin)
    
    ' Acquisition Parameters
    Public FastCount As Double         ' fast channel count
    Public SlowCount As Double         ' slow channel count
    Public AccumulationTime As Double  ' real time duration of present data acquisition interval

    ' Acquisition Mode
    Public StatMcaEnabled As Byte      ' mca enabled status, high during acq, preset time resets flag
    Public MCSDone As Byte             ' MCS done flag 1=finished, 0=not finished
    Public PresetCountExpired As Byte  ' indicates presets counts have been reached

'End Type


